using System;
using System.Collections.Generic;
using System.Text;
using System.Security.Cryptography;
using System.Text.RegularExpressions;
using FnacDirect.OrderPipe.CM.Model;
using FnacDirect.OrderPipe.Base.DAL;
using FnacDirect.OrderPipe.Base.Model;
using FnacDirect.Membership.Business;
using FnacDirect.Membership.Model.Entities;
using FnacDirect.Customer.BLL;
using FnacDirect.Customer.Model;
using System.Linq;
using FnacDirect.FnacStore.Business;
using FnacDirect.Technical.Framework.CoreServices;
using FnacDirect.Technical.Framework.DnsCheck;
using FnacDirect.Technical.Framework.CoreServices.Localization;
using FnacDirect.Technical.Framework.Web;
using FnacDirect.Technical.Framework.ServiceLocation;
using FnacDirect.OrderPipe.Base.Model.UserInformations;
using FnacDirect.Contracts.Online.Model;

namespace FnacDirect.OrderPipe.CM.Business
{
    public class ClickAndMagBusiness : IClickAndMagBusiness
    {
        private readonly ICustomerDAL _customerDal;
        private readonly INewAdhesionFDVDal _newAdhDal;

        public ClickAndMagBusiness(ICustomerDAL customerDal, INewAdhesionFDVDal newAdhDal)
        {
            _customerDal = customerDal;
            _newAdhDal = newAdhDal;
        }

        private IFnacStoreBusiness _storeBusiness;
        protected IFnacStoreBusiness StoreBusiness
        {
            get
            {
                if (_storeBusiness == null)
                    _storeBusiness = ServiceLocator.Current.GetInstance<IFnacStoreBusiness>();
                return _storeBusiness;
            }
        }

        /// <summary>
        /// Réalise une recherche en base de données des comptes Fnac.com correspondant à la liste des
        /// critères de recherche passée en paramètre
        /// </summary>
        public List<CustomerWithAddress> FindCustomers(Dictionary<CustomerSearchField, string> criterias)
        {
            return _customerDal.FindCustomers(criterias);
        }

        /// <summary>
        /// Réalise une recherche en base de données/WS des comptes adhérents
        /// correspondants à la liste des critères de recherche passée en 
        /// paramètre.
        /// </summary>
        /// <param name="criterias"></param>
        /// <returns></returns>
        public List<Member> FindAdherents(Dictionary<AdherentSearchField, string> criterias, string login, string magasin, out bool maxAtteint)
        {
            var smb = new SearchMembershipBusiness();
            var nom = string.Empty;
            if (criterias.ContainsKey(AdherentSearchField.LastName))
                nom = criterias[AdherentSearchField.LastName];
            var prenom = string.Empty;
            if (criterias.ContainsKey(AdherentSearchField.FirstName))
                prenom = criterias[AdherentSearchField.FirstName];
            var email = string.Empty;
            if (criterias.ContainsKey(AdherentSearchField.EmailAddress))
                email = criterias[AdherentSearchField.EmailAddress];
            var telephone = string.Empty;
            if (criterias.ContainsKey(AdherentSearchField.PhoneNumber))
                telephone = criterias[AdherentSearchField.PhoneNumber];
            DateTime? dateNaissance = null;
            if (criterias.ContainsKey(AdherentSearchField.BirthDate))
                dateNaissance = DateTime.Parse(criterias[AdherentSearchField.BirthDate]);

            var members = smb.SearchMembership(login, magasin, nom, prenom, email, telephone, dateNaissance, out maxAtteint);

            return members;
        }

        /// <summary>
        /// Permet de récupérer un objet store initialisé en fonction
        /// de son Id en base de données
        /// </summary>
        public FnacStore.Model.FnacStore GetStoreById(int storeId)
        {
            return StoreBusiness.GetStoreById(storeId);
        }

        /// <summary>
        /// Permet de récupérer une adresse mail autogénérée en fonction
        /// du nom et du prénom du client
        /// (prenom.NOM[cpt]@domaine, ou cpt est un nombre auto-incrémenté)
        /// </summary>
        /// <param name="firstname">Prénom du client</param>
        /// <param name="lastname">Nom du client</param>
        /// <param name="domain">Domaine de l'adresse autogénérée</param>
        public string GetAutogeneratedCustomerMail(string firstname, string lastname, string domain)
        {
            if (string.IsNullOrEmpty(firstname))
                throw new ArgumentNullException("firstname");
            if (string.IsNullOrEmpty(lastname))
                throw new ArgumentNullException("lastname");
            if (string.IsNullOrEmpty(domain))
                throw new ArgumentNullException("domain");

            // On retire les carctères spéciaux du nom et du prénom pour créer l'email
            var rgx = new Regex("[^a-zA-Z0-9._%+-]");
            firstname = rgx.Replace(firstname, string.Empty);
            lastname = rgx.Replace(lastname, string.Empty);
            lastname = lastname.Replace(" ", "");
            lastname = GuptHelper.FormatGUPTData(lastname).ToUpperInvariant();
            firstname = firstname.Replace(" ", "");
            firstname = GuptHelper.FormatGUPTData(firstname).ToLowerInvariant();


            var currentCpt = GetMaxCompteurAutogeneratedMail(firstname, lastname, domain);
            if (currentCpt > 0)
                return string.Format("{0}.{1}{2}@{3}", firstname, lastname, currentCpt, domain);
            else
                return string.Format("{0}.{1}@{2}", firstname, lastname, domain);

        }

        /// <summary>
        /// Récupere la valeur du compteur d'incrément pour un mail autogénéré.
        /// </summary>
        /// <param name="firstname">Prénom du client</param>
        /// <param name="lastname">Nom du client</param>
        /// <param name="domain">Domaine de l'adresse autogénérée</param>
        /// <returns>0 si il nexiste pas encore d'adresse mail semblable, un nombre positif
        /// pour indiquer la prochaine valeur disponible</returns>
        private int GetMaxCompteurAutogeneratedMail(string firstname, string lastname, string domain)
        {
            var cpt = 0;
            var rmail = new Regex(string.Format(@"^({0}.{1})(\d*)(@{2})$", firstname.ToUpperInvariant(), lastname.ToUpperInvariant(), domain.ToUpperInvariant()));
            var mails = _customerDal.SearchAutogeneratedMailAccount(firstname.ToUpperInvariant(), lastname.ToUpperInvariant(), domain.ToUpperInvariant());
            foreach (var mail in mails)
            {
                var m = rmail.Match(mail.ToUpperInvariant());
                if (m.Success && m.Groups.Count > 3)
                {
                    var tmpCpt = -1;
                    if (int.TryParse(m.Groups[2].Value, out tmpCpt) && tmpCpt >= cpt)
                        cpt = tmpCpt;
                }
            }
            if (mails.Count == 0)//Aucun mail similaire n'a put etre trouvé
                return 0;
            else //On a trouvé au moins un mail similaire et l'on incrémente donc le compteur courant
                return ++cpt;
        }

        /// <summary>
        /// Permet de récupérer les informations du client à partir d'un numéro de carte adhérent
        /// et des infos contenues dans les tables d'adhésion
        /// </summary>
        /// <param name="cardNumber">Numéro de carte</param>
        /// <param name="cad">Parametre de groupe utilisée pour la création d'un compte client
        /// sur le pipe Click et Mag</param>
        public void GetCustomerInfosFromPlasticCardNumber(string cardNumber, CreateAccountData cad)
        {
            _newAdhDal.GetCustomerInfosFromPlasticCardNumber(cardNumber, cad);
        }

        /// <summary>
        /// Permet de récupérer les informations du client à partir d'un numéro d'adhérent
        /// et des infos contenues dans les tables d'adhésion
        /// </summary>
        /// <param name="adherentNumber">Numéro d'adhérent</param>
        /// <param name="cad">Parametre de groupe utilisée pour la création d'un compte client
        /// sur le pipe Click et Mag</param>
        public void GetCustomerInfosFromAdherentNumber(string adherentNumber, DateTime? birthDate, CreateAccountData cad)
        {
            _newAdhDal.GetCustomerInfosFromAdherentNumber(adherentNumber, birthDate, cad);
        }

        public bool IsAutoGeneratedMail(string mail, string autoGeneratedMailDomain)
        {
            if (string.IsNullOrEmpty(mail) || string.IsNullOrEmpty(autoGeneratedMailDomain))
                return false;

            var s = mail.Split('@');
            if (s.Length > 1 && s[1].ToUpperInvariant().Equals(autoGeneratedMailDomain.ToUpperInvariant()))
                return true;
            else
                return false;
        }

        public bool IsHomeShipping(IEnumerable<LineGroup> lineGroups)
        {
            return lineGroups.Any(lg => lg.ShippingAddress is PostalAddress);
        }


        /// <summary>
        /// Met à jour le champ indiquant si le client accepte de recevoir des 
        /// informations par SMS.
        /// </summary>
        /// <param name="customerId"></param>
        /// <param name="allowSMS"></param>
        public void SetAllowSMS(int customerId, bool allowSMS)
        {
            var mailAttributeBusiness = new MailAttributeBusiness();
            var mailAttributeEntity = new MailAttributeEntity
            {
                MailAttributeTypeId = (int)MailAttributeTypeEnum.SMS_NEWSLETTER,
                Subscribe = allowSMS
            };
            mailAttributeBusiness.Update(customerId, mailAttributeEntity);
        }

        /// <summary>
        /// Renvoie vrai ssi le customer accepte de recevoir des informations 
        /// par SMS.
        /// </summary>
        /// <param name="customerId"></param>
        /// <returns></returns>
        public bool GetAllowSMS(int customerId)
        {
            bool allowSMS;
            var mailAttributeBusiness = new MailAttributeBusiness();
            List<MailAttributeEntity> mailAttributeEntities;
            mailAttributeEntities = mailAttributeBusiness.Populate(customerId);
            var mailAttributeEntity = mailAttributeEntities.Find(
                delegate(MailAttributeEntity mae)
                {
                    return mae.MailAttributeTypeId == (int)MailAttributeTypeEnum.SMS_NEWSLETTER;
                });
            if (mailAttributeEntity != null && mailAttributeEntity.Subscribe.HasValue && mailAttributeEntity.Subscribe.Value)
            {
                allowSMS = true;
            }
            else
            {
                allowSMS = false;
            }

            return allowSMS;
        }

        /// <summary>
        /// Met à jour le téléphone portable du client.
        /// </summary>
        /// <param name="customerId"></param>
        /// <param name="cellPhone"></param>
        public void SetCellPhone(int customerId, string cellPhone)
        {
            var attributeBusiness = new AttributBusiness();
            var attributeEntity = new AttributEntity
            {
                AttributeId = (int)AttributeType.MSISDN,
                AttributeValue = cellPhone,
                CustomerId = customerId
            };
            attributeBusiness.Update(attributeEntity);

        }

        /// <summary>
        /// Renvoie le numéro de portable du client.
        /// </summary>
        /// <param name="customerId"></param>
        /// <returns></returns>
        public string GetCellPhone(int customerId)
        {
            var ab = new AttributBusiness();
            var ae = ab.Populate(customerId, (int)AttributeType.MSISDN);

            return ae.AttributeValue;
        }

        /// <summary>
        /// Generate a hash key from OrderForm for ShopArticles only
        /// </summary>
        /// <param name="orderForm">The current OrderForm</param>
        /// <returns></returns>
        public byte[] CalcShopArticleThumbprint(IEnumerable<StandardArticle> articles, IUserContextInformations userContextInformations, int idShop, Seller seller)
        {
            return CalcShopArticleThumbprint(articles, userContextInformations, idShop, seller.Number);
        }

        /// <summary>
        /// Generate a hash key from OrderForm for ShopArticles only without a defined Seller
        /// </summary>
        /// <param name="orderForm">The current OrderForm</param>
        /// <returns></returns>
        public byte[] CalcShopArticleThumbprint(IEnumerable<StandardArticle> articles, IUserContextInformations userContextInformations, int idShop)
        {
            return CalcShopArticleThumbprint(articles, userContextInformations, idShop, -1);
        }

        private byte[] CalcShopArticleThumbprint(IEnumerable<StandardArticle> articles, IUserContextInformations userContextInformations, int idShop, int sellerNumber)
        {
            var lst = new List<string>();
            foreach (var shop in articles)
            {
                lst.Add(string.Format("Shop:{0}:{1}:{2}:{3}:{4}:{5}", shop.ProductID.GetValueOrDefault(), shop.Referentiel, shop.Quantity.GetValueOrDefault(), shop.PriceUserEur.GetValueOrDefault(), userContextInformations.UID, idShop, sellerNumber));
                foreach (var srv in shop.Services)
                {
                    lst.Add(string.Format("SVC:{0}:{1}:{2}:{3}:{4}:{5}:{6}:{7}", srv.ProductID.GetValueOrDefault(), srv.Referentiel, srv.Quantity, srv.PriceUserEur.GetValueOrDefault(), shop.ProductID.GetValueOrDefault(), shop.Referentiel, userContextInformations.UID, idShop, sellerNumber));
                }
            }
            lst.Sort();
            var buf = string.Join("\n", lst.ToArray());
            var md5 = MD5.Create();

            return md5.ComputeHash(Encoding.ASCII.GetBytes(buf));
        }

        /// <summary>
        /// return type of CheckEmailStruct for MVC.
        /// </summary>
        public struct EmailStatus
        {
            public int Status;
            public string Msg;
        };

        /// <summary>
        /// Check if the given email is valide and return EmailStatus structure.
        /// </summary>
        /// <param name="email"></param>
        /// <param name="culture"></param>
        /// <returns></returns>
        public int CheckEmail(string email, string culture, out string message)
        {
            if (!string.IsNullOrEmpty(email))
            {
                // Validation via le DNS
                if (!ConfigurationManager.Current.Maintenance.DnsCheck)
                {
                    // Vérif. via regex
                    if (!DnsChecker.isEmail(email)) 
                    {
                        message = MessageHelper.Get(FnacContext.Current.SiteContext, "OP.ModifyAccount.CheckMail.InvalidEmail.FDV");
                        return 1;
                    }
                    var dnsWatch = new DnsCheckerWatch();
                    // Vérif. via DNS
                    if (!dnsWatch.CheckServerWithTimeOut(
                        email,
                        TimeSpan.Parse(System.Configuration.ConfigurationManager.AppSettings["TimeToLifeForMxMailRequest"])))
                    {
                        message = MessageHelper.Get(FnacContext.Current.SiteContext, "OP.ModifyAccount.CheckMail.InvalidDNS.FDV");
                        return 2;
                    }
                }
            }

            // Vérif. email déjà utilisé ou pas
            var custBiz = new CustomerBusiness();
            if (!custBiz.CheckEmailAvailability(email))
            {
                message = MessageHelper.Get(FnacContext.Current.SiteContext, "OP.ModifyAccount.CheckMail.AlreadyUsed.FDV");
                return 3;

            }
            message = string.Empty;
            return 0;
        }
    }
}
